package dalhelper

import (
	"sync"
	"time"

	"corelab.mkcl.org/MKCLOS/coredevelopmentplatform/coreospackage/confighelper"
	_ "github.com/go-sql-driver/mysql"

	"github.com/gocraft/dbr"
)

// Hold a single global connection (pooling provided by sql driver)
var sqlConnection *dbr.Connection
var connectionError error
var sqlOnce sync.Once

//GetSQLConnection to db
// func GetSQLConnection() (*dbr.Connection, error) {
// 	sqlOnce.Do(func() {
// 		// create a connection db(e.g. "postgres", "mysql", or "sqlite3")
// 		connection, err := dbr.Open("mysql", confighelper.GetConfig("MysqlDSN"), nil)
// 		if err != nil {
// 			connectionError = err
// 		}
// 		//	connection.SetMaxIdleConns(10)
// 		//	connection.SetMaxOpenConns(5)
// 		sqlConnection = connection
// 	})
// 	return sqlConnection, connectionError
// }
//GetSQLConnection to db
func GetSQLConnection() (*dbr.Connection, error) {
	sqlOnce.Do(func() {
		// create a connection db(e.g. "postgres", "mysql", or "sqlite3")
		connection, err := dbr.Open("mysql", confighelper.GetConfig("MysqlDSN"), nil)
		if err != nil {
			connectionError = err
		}
		connection.SetMaxIdleConns(100)
		connection.SetMaxOpenConns(5000)
		duration := 3 * 24 * time.Hour
		connection.SetConnMaxLifetime(duration)
		sqlConnection = connection
	})
	return sqlConnection, connectionError
}
